// gp_demoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "gp_demo.h"
#include "gp_demoDlg.h"
#include ".\gp_demodlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl 'Info'

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cgp_demoDlg Dialogfeld

Cgp_demoDlg::Cgp_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cgp_demoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_hGPDll = NULL;

	m_sSLText1 = L"This is Single Line 1";
	m_sSLText2 = L"This is Single Line 2";
	m_sSLText3 = L"This is Single Line 3";
	m_sSLText4 = L"This is Single Line 4";
	m_sSLText5 = L"This is Single Line 5";

	m_sMLText = L"This\r\nis a\r\nmulti-line text.";
}

void Cgp_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SCREENSIZEEDIT, m_sScreenSizeText);
	DDX_Text(pDX, IDC_INGAMETEXT_SL1_EDIT, m_sSLText1);
	DDX_Text(pDX, IDC_INGAMETEXT_SL2_EDIT, m_sSLText2);
	DDX_Text(pDX, IDC_INGAMETEXT_SL3_EDIT, m_sSLText3);
	DDX_Text(pDX, IDC_INGAMETEXT_SL4_EDIT, m_sSLText4);
	DDX_Text(pDX, IDC_INGAMETEXT_SL5_EDIT, m_sSLText5);
	DDX_Text(pDX, IDC_INGAMETEXT_ML_EDIT, m_sMLText);
}

BEGIN_MESSAGE_MAP(Cgp_demoDlg, CDialog)
    ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &Cgp_demoDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_SCREENSIZEBUTTON, &Cgp_demoDlg::OnBnClickedScreensizebutton)
	ON_BN_CLICKED(IDC_TOGGLESHOWFPSBUTTON, &Cgp_demoDlg::OnBnClickedToggleshowfpsbutton)
	ON_BN_CLICKED(IDC_TOGGLE_SL1_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl1Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL2_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl2Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL3_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl3Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL4_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl4Button)
	ON_BN_CLICKED(IDC_TOGGLE_SL5_BUTTON, &Cgp_demoDlg::OnBnClickedToggleSl5Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML1_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl1Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML2_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl2Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML3_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl3Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML4_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl4Button)
	ON_BN_CLICKED(IDC_TOGGLE_ML5_BUTTON, &Cgp_demoDlg::OnBnClickedToggleMl5Button)
	ON_BN_CLICKED(IDC_SET_PIC_BUTTON3, &Cgp_demoDlg::OnBnClickedSetPicButton3)
	ON_BN_CLICKED(IDC_SET_PIC_BUTTON4, &Cgp_demoDlg::OnBnClickedSetPicButton4)
END_MESSAGE_MAP()


// Cgp_demoDlg Meldungshandler

BOOL Cgp_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

 	// GPCOMMS.DLL
#if defined _M_IX86
	m_hGPDll = LoadLibrary(L"gpcomms.dll"); 
#else
	m_hGPDll = LoadLibrary(L"gpcomms_64.dll"); 
#endif

    if (!m_hGPDll) 
    {
#if defined _M_IX86
		AfxMessageBox(L"GPCOMMS.DLL not found !", MB_ICONSTOP);
#elif defined _M_X64
		AfxMessageBox(L"GPCOMMS_64.DLL not found !", MB_ICONSTOP);
#endif
        ::PostQuitMessage(0);
        return(true);
    }

    GPSL_SetTextLineData		= (GPSL_SETTEXTLINEDATA) GetProcAddress(m_hGPDll, "GPSL_SetTextLineData"); 
    GPSL_ShowText				= (GPSL_SHOWTEXT) GetProcAddress(m_hGPDll, "GPSL_ShowText"); 
    GPML_SetTextMultilineData	= (GPML_SETTEXTMULTILINEDATA) GetProcAddress(m_hGPDll, "GPML_SetTextMultilineData"); 
    GPML_ShowText				= (GPML_SHOWTEXT) GetProcAddress(m_hGPDll, "GPML_ShowText"); 
    GPPIC_LoadNewPicture		= (GPPIC_LOADNEWPICTURE) GetProcAddress(m_hGPDll, "GPPIC_LoadNewPicture");
    GPPIC_ShowPicturePos		= (GPPIC_SHOWPICTUREPOS) GetProcAddress(m_hGPDll, "GPPIC_ShowPicturePos");
	GPSI_GetScreenSize			= (GPSI_GETSCREENSIZE) GetProcAddress(m_hGPDll, "GPSI_GetScreenSize");
	GPSI_ShowFPS				= (GPSI_SHOWFPS) GetProcAddress(m_hGPDll, "GPSI_ShowFPS");
	GPSS_MakeScreenshot			= (GPSS_MAKESCREENSHOT) GetProcAddress(m_hGPDll, "GPSS_MakeScreenshot");

	if (!GPSL_SetTextLineData || !GPSL_ShowText        || !GPML_SetTextMultilineData ||
		!GPML_ShowText        || !GPPIC_LoadNewPicture || !GPPIC_ShowPicturePos      ||
		!GPSI_GetScreenSize   || !GPSI_ShowFPS         || !GPSS_MakeScreenshot)
    {
        AfxMessageBox(L"GPCOMMS.DLL: One or more exported functions not found !",MB_ICONSTOP);
        ::PostQuitMessage(0);
        return(true);
    }

	UpdateData(false);

    return(true);  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void Cgp_demoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void Cgp_demoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR Cgp_demoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL Cgp_demoDlg::DestroyWindow()
{
	DB(L"Cgp_demoDlg::DestroyWindow called.\r\n");
    return CDialog::DestroyWindow();
}

void Cgp_demoDlg::CleanUp()
{
	DB(L"Cgp_demoDlg::CleanUp called.\r\n");

    // the communications wrapper dll
    if (m_hGPDll) 
    {
        FreeLibrary(m_hGPDll);
        m_hGPDll = NULL;
    }    
}

void Cgp_demoDlg::OnBnClickedOk()
{
	CleanUp();
	OnOK();
}

void Cgp_demoDlg::OnCancel()
{
	CleanUp();
	CDialog::OnCancel();
}

void Cgp_demoDlg::OnBnClickedScreensizebutton()
{
	int x, y;
	GPSI_GetScreenSize(&x, &y);
	UpdateData(true);
	m_sScreenSizeText.Format(L"%i x %i", x, y);
	UpdateData(false);
}

void Cgp_demoDlg::OnBnClickedToggleshowfpsbutton()
{
	static bool bShowIt = false;
	bShowIt = !bShowIt;
	GPSI_ShowFPS(bShowIt);
}

void Cgp_demoDlg::OnBnClickedToggleSl1Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 0;
	WORD wTextPosX = 10;
	WORD wTextPosY = 50;
	DWORD dwTextColor = D3DCOLOR_ARGB(255, 255, 0, 0);
	bool bBlackBackground = false;
	BYTE cSize = 32;
	bool bTextBold = false;
	BYTE cFontFamily = 0;

	GPSL_SetTextLineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sSLText1, dwTextColor, bBlackBackground, cSize, bTextBold, cFontFamily);
	GPSL_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleSl2Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 1;
	WORD wTextPosX = 10;
	WORD wTextPosY = 100;
	DWORD dwTextColor = D3DCOLOR_ARGB(255, 255, 0, 0);
	bool bBlackBackground = true;
	BYTE cSize = 24;
	bool bTextBold = false;
	BYTE cFontFamily = 1;

	GPSL_SetTextLineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sSLText2, dwTextColor, bBlackBackground, cSize, bTextBold, cFontFamily);
	GPSL_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleSl3Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 2;
	WORD wTextPosX = 10;
	WORD wTextPosY = 150;
	DWORD dwTextColor = D3DCOLOR_ARGB(200, 0, 255, 0);
	bool bBlackBackground = false;
	BYTE cSize = 32;
	bool bTextBold = true;
	BYTE cFontFamily = 1;

	GPSL_SetTextLineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sSLText3, dwTextColor, bBlackBackground, cSize, bTextBold, cFontFamily);
	GPSL_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleSl4Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 3;
	WORD wTextPosX = 10;
	WORD wTextPosY = 200;
	DWORD dwTextColor = D3DCOLOR_ARGB(150, 0, 0, 255);
	bool bBlackBackground = true;
	BYTE cSize = 24;
	bool bTextBold = false;
	BYTE cFontFamily = 0;

	GPSL_SetTextLineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sSLText4, dwTextColor, bBlackBackground, cSize, bTextBold, cFontFamily);
	GPSL_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleSl5Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 4;
	WORD wTextPosX = 10;
	WORD wTextPosY = 250;
	DWORD dwTextColor = D3DCOLOR_ARGB(100, 255, 0, 255);
	bool bBlackBackground = false;
	BYTE cSize = 32;
	bool bTextBold = true;
	BYTE cFontFamily = 0;

	GPSL_SetTextLineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sSLText5, dwTextColor, bBlackBackground, cSize, bTextBold, cFontFamily);
	GPSL_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleMl1Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 0;
	WORD wTextPosX = 400;
	WORD wTextPosY = 10;
	DWORD dwTextColor = D3DCOLOR_ARGB(250, 255, 255, 0);
	bool bBlackBackground = true;
	BYTE cSize = 30;
	bool bTextBold = false;
	BYTE cFontFamily = 1;
	WORD wSizeX = 300;
	WORD wSizeY = 150;

	GPML_SetTextMultilineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sMLText, dwTextColor, bBlackBackground, cSize, bTextBold, wSizeX, wSizeY, cFontFamily);
	GPML_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleMl2Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 1;
	WORD wTextPosX = 500;
	WORD wTextPosY = 110;
	DWORD dwTextColor = D3DCOLOR_ARGB(250, 0, 255, 255);
	bool bBlackBackground = false;
	BYTE cSize = 30;
	bool bTextBold = true;
	BYTE cFontFamily = 0;
	WORD wSizeX = 300;
	WORD wSizeY = 200;

	GPML_SetTextMultilineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sMLText, dwTextColor, bBlackBackground, cSize, bTextBold, wSizeX, wSizeY, cFontFamily);
	GPML_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleMl3Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 2;
	WORD wTextPosX = 400;
	WORD wTextPosY = 210;
	DWORD dwTextColor = D3DCOLOR_ARGB(250, 255, 255, 0);
	bool bBlackBackground = false;
	BYTE cSize = 30;
	bool bTextBold = false;
	BYTE cFontFamily = 1;
	WORD wSizeX = 300;
	WORD wSizeY = 200;

	GPML_SetTextMultilineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sMLText, dwTextColor, bBlackBackground, cSize, bTextBold, wSizeX, wSizeY, cFontFamily);
	GPML_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleMl4Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 3;
	WORD wTextPosX = 500;
	WORD wTextPosY = 310;
	DWORD dwTextColor = D3DCOLOR_ARGB(250, 0, 0, 255);
	bool bBlackBackground = false;
	BYTE cSize = 30;
	bool bTextBold = true;
	BYTE cFontFamily = 0;
	WORD wSizeX = 300;
	WORD wSizeY = 200;

	GPML_SetTextMultilineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sMLText, dwTextColor, bBlackBackground, cSize, bTextBold, wSizeX, wSizeY, cFontFamily);
	GPML_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedToggleMl5Button()
{
	UpdateData(true);

	BYTE cObjectNumber = 4;
	WORD wTextPosX = 400;
	WORD wTextPosY = 410;
	DWORD dwTextColor = D3DCOLOR_ARGB(250, 0, 100, 0);
	bool bBlackBackground = false;
	BYTE cSize = 30;
	bool bTextBold = true;
	BYTE cFontFamily = 1;
	WORD wSizeX = 300;
	WORD wSizeY = 200;

	GPML_SetTextMultilineData(cObjectNumber, wTextPosX, wTextPosY, (LPCWSTR)m_sMLText, dwTextColor, bBlackBackground, cSize, bTextBold, wSizeX, wSizeY, cFontFamily);
	GPML_ShowText(cObjectNumber, true);
}

void Cgp_demoDlg::OnBnClickedSetPicButton3()
{
	CString sLoadPath;
	GetModuleFileName(NULL, CStrBuf(sLoadPath, MAX_PATH), MAX_PATH);
	PathRemoveFileSpec(CStrBuf(sLoadPath, MAX_PATH));
	sLoadPath.Append(L"\\testimage.jpg");
	
	GPPIC_LoadNewPicture((LPCWSTR)sLoadPath);
	GPPIC_ShowPicturePos(true, 400, 500);
}

void Cgp_demoDlg::OnBnClickedSetPicButton4()
{
	CString sSavePath;
	GetModuleFileName(NULL, CStrBuf(sSavePath, MAX_PATH), MAX_PATH);
	PathRemoveFileSpec(CStrBuf(sSavePath, MAX_PATH));
	sSavePath.Append(L"\\screenshot.jpg");

	GPSS_MakeScreenshot(true, (LPCWSTR)sSavePath);
}
