#pragma once

// Exported creator functions
IDirect3D9* WINAPI Direct3DCreate9 (UINT SDKVersion);
HRESULT     WINAPI Direct3DCreate9Ex(UINT SDKVersion, IDirect3D9Ex**);

// Exported functions: DX9c
int         WINAPI D3DPERF_BeginEvent(D3DCOLOR col, LPCWSTR wszName);
int         WINAPI D3DPERF_EndEvent(void);
void        WINAPI D3DPERF_SetMarker(D3DCOLOR col, LPCWSTR wszName);
void        WINAPI D3DPERF_SetRegion(D3DCOLOR col, LPCWSTR wszName);
BOOL        WINAPI D3DPERF_QueryRepeatFrame(void);
void        WINAPI D3DPERF_SetOptions(DWORD dwOptions);
DWORD       WINAPI D3DPERF_GetStatus(void);


void        WINAPI Direct3DShaderValidatorCreate9(void);
HRESULT     WINAPI PSGPError(void);           // Not sure if this is actually correct
HRESULT     WINAPI PSGPSampleTexture(void);   // Not sure if this is actually correct
HRESULT     WINAPI DebugSetLevel(void);
void        WINAPI DebugSetMute(void);

// regular functions
void InitInstance(HANDLE hModule);
void ExitInstance(void);
void LoadOriginalDll(void);
void ShowStartupScreen(void);